#define _XOPEN_SOURCE 1
#define _XOPEN_SOURCE_EXTENDED 1
#include <unistd.h>
#include <limits.h>

static char const prog[]="seek0";

int main(int argc, char** argv) {
  for (argc=(argc!=0); argv[argc]!=null; ++argc) {
    char const* const arg=argv[argc];
    unsigned long fd;
    unsigned int const len=scan_ulong(arg, &fd);

    if (len==0 || arg[len]!='\0')
      strerr_die6x(111, prog, fatal, arg_fd, err_malformed, err_, arg);

    if (fd>INT_MAX)
      strerr_die5x(100, prog, fatal, arg_fd, err_oflow, t_int);

    switch (seek0(fd)) {
      case seek0_success: break;
      case seek0_lseek:
        strerr_die5sys(100, prog, fatal, err_unable, "lseek", err_);
      default:
        strerr_die4sys(111, prog, fatal, err_unknown, err_);
    }
  }

  _exit(0);
}
